#define PROF         2   // (Middle edition for 98/Me) in string table
                         // (Evaluation copy) (Light edition)
#define TR           0   // Menu Tools
#define TR_SM        1   // save mode (it must be 0 for final release)
#define UNIX_TR      0

#define v32_64       64  // 32 or 64
#define v4_8         (v32_64/8)
#define CONSOLE      1
#define UNIX         1
#define MY_SQL       1   // CONSOLE<=UNIX<=MY_SQL
#define QT_GRAPHIC   0   // CONSOLE<=UNIX<=QT_GRAPHIC
#define PLUG_IN      0
#define SHAREWARE    0
#define EVAL_PERIOD  31  // 3*31

// TODO for UNIX: PROF=2, TR=0, CONSOLE=UNIX=MY_SQL=1, UNIX_TR=(0 or 1), delete _WIN64 

#define INIT_NEW_MEM   0  // you do not need to init the new memory
#define INIT_VAL       33 // the natural init value is 0
#define CHECK_NEW_MEM  0  // you do not need to check the new memory

#define DUMP         0  // only for debugging
#define ALL_DUMPS    1  // how many dump files

#define CHECK_ARRAYS_RANGE  0  // only for debugging with transformed files
#define ARRAYS_NUM         74  // 73 plus one for zero // from 70 to 72 maybe are free

#define OLD_TERMS    1
#define FUNC3        3   // 2 or 3 (move from 2 to 3)

#define ADDED_FILES   64

#if CONSOLE

#if v32_64==32
#define MY_WORD      unsigned
#define MY_INT       int
#define MY_FLOAT     float
#define LP_MY_WORD   unsigned *
#else
#define MY_WORD      unsigned long
#define MY_INT       long
#define MY_FLOAT     double
#define LP_MY_WORD   unsigned long *
#endif

#define DWORD     unsigned
#define LPDWORD   unsigned *
#define MY_LONG   unsigned long
#define MY_LONG_INT        long

#else // CONSOLE

#if v32_64==32
typedef unsigned __int32  MY_WORD; // long
typedef __int32 MY_INT;
typedef float   MY_FLOAT;
#else
typedef unsigned __int64  MY_WORD; // long long
typedef __int64 MY_INT;
typedef double  MY_FLOAT;
#endif
typedef unsigned __int64  MY_LONG;
typedef          __int64  MY_LONG_INT;
typedef MY_WORD far      *LP_MY_WORD;

#endif // CONSOLE

#if v32_64==32
#define G_STR   "%lG"
#else
#define G_STR   "%.9lG"
#endif

#if PROF
#define BUFFERS      (long)8192
#define L_BUFER      (long)49148  // 3*light, for string2, atom_buf - maximal string in Str.Store //32 for test
#define MAX_ARGUMENTS 4096
/* MAX_VARS is maximum substitusions in one unification or maximum variables in the atom and in the head */
// MAX_VARS has to be < 32,000 because has to be < S_MASKA-TT_START
#define MAX_VARS     (long)16384   /* Change MAX_VARS here */
#define TROOF_TREE_ATOMS     200

#else
#define BUFFERS      (long)2048
#define L_BUFER      (long)16380  // -REZ_4 for +REZ_4
#define MAX_ARGUMENTS 1024
#define MAX_VARS     (long)4096
#define TROOF_TREE_ATOMS     50
#endif // PROF


#define REZ_4               4  // for print_file ( <^v: ) we need 3 but 4 to be even
#define AND_OR              32 // Maximum 32x32 bit=1024 arguments
#define FIRST_ROWS          10
#define LAST_COLOR          14
#define CHAR_SETS           26
#define LISTS_INCREASE      256
#define INCREASE_C          2048

#define K_SP_TYPES          5

#define TC_COMMA           82
#define TC_V_LINE          83

#define my_max(a,b)     (((a)>(b))?(a):(b))
#define my_min(a,b)     (((a)<(b))?(a):(b))

#if OLD_TERMS
#define TT_ADD               0
#define TT_START           256
#define TT_USED            124 // used for open bracket (
#define TT_SET             125 // like_set_const
#define TT_LIST            126 // []
#define TT_VAR             127
#define TT_LINK            128
#define TT_STR             129
#define TT_INT             130
#define TT_FLOAT           131
#define TT_OBJ             132

#else

#define TT_ADD             132
#define TT_START           512 // 512 or 265 (256+9)
#define TT_USED            256 // ???
#define TT_SET             257
#define TT_LIST            258
#define TT_VAR             259
#define TT_LINK            260
#define TT_STR             261
#define TT_INT             262
#define TT_FLOAT           263
#define TT_OBJ             264
#endif

#if OLD_TERMS
#define TT_C_A              37
#define TT_C_B              38
#define TT_C_C              39
#define TT_C_D              40
#define TT_C_E              41
#define TT_C_F              42
#define TT_C_Eb             14
#define TT_C_H              44
#define TT_C_I              45
#define TT_C_J              46
#define TT_C_L              48
#define TT_C_N              50
#define TT_C_O              51
#define TT_C_S              55
#define TT_C_T              56
#define TT_C_U              57
#define TT_C_V              58
#define TT_C_W              59
#define TT_C_X              60
#define TT_C_NODIV          63
#define TT_C_POINT          67
#define TT_C_PLUS           72
#define TT_C_MINUS          73
#define TT_C_DIV            74
#define TT_C_QUESTION       65
#define TT_C_CUT            80
#define TT_C_APOSTROPHE     137

#else

#define TT_C_I             106
#define TT_C_S             116
#define TT_C_QUESTION       63
#define TT_C_CUT            33
#endif

#define CLASS_OBJECT               10 // 0  ...
#define CLASS_SYSTEM               20 // 0 01 ...
#define CLASS_S_CLASS              30 // 0 01 0001 ...
#define CLASS_SYSTEM_FILE          40 // 0 01 0011...
#define CLASS_SYSTEM_LIST          50 // 0 01 0000 ...
#define CLASS_SYSTEM_ActiveX       60 // 0 01 0001 ...
#define CLASS_SYSTEM_PEN           70 // 0 01 1010...
#define CLASS_SYSTEM_BRUSH         80 // 0 01 1001...
#define CLASS_SYSTEM_FONT          90 // 0 01 1011...
#define CLASS_SYSTEM_FONTMASK     100 // 0 01 1100...
#define CLASS_SYSTEM_BITMAP       110 // 
#define CLASS_SYSTEM_TIMER        120 // 0 01 1000...
#define CLASS_SYSTEM_DLL          130 // 0 01 1101...
#define CLASS_SYSTEM_SOCKET       140 // 0 01 0100...
#define CLASS_SYSTEM_MYSQL        150 // 0 01 0101...
#define CLASS_SYSTEM_MYSQL_RES    160 // 0 01 0110...
#define CLASS_SYSTEM_MYSQL_ROW    170 // 0 01 0111 ...
#define CLASS_SYSTEM_CONTAINER    180 // 0 01 0010 ...
#define CLASS_SYSTEM_MENU         190 // 0 01 1110...
#define C_S_WIN                   220 // 0 01 1110...
#define C_S_WIN_Main              230 // 0 01 1110 0001...
#define C_S_WIN_Dialog            240 // 0 01 1110 0010...
#define C_S_WIN_Static            250 // 0 01 1110 0101...
#define C_S_WIN_Edit              260 // 0 01 1110 0110...
#define C_S_WIN_Slider            270 // 0 01 1110 0110...
#define C_S_WIN_ScrollBar         280 // 0 01 1110 0110...
#define C_S_WIN_Animate           290 // 0 01 1110...
#define C_S_WIN_ListBox           300 // 0 01 1110 0111...
#define C_S_WIN_TreeBox           310 // 0 01 1110 0111...
#define C_S_WIN_Bitmap            320 // 0 01 1110...
#define C_S_WIN_Icon              330 // 0 01 1110...
#define C_S_WIN_Button            340 // 0 01 1110 0011...
#define C_S_WIN_CheckBox          350 // ?????
#define C_S_WIN_Embedded          360 // ????? // this has to be the last (the bottom)

#define SM1          0xffff             /* -1 or the bigest unsigned word */
#define SM2          0xfffe
#define NUL          0

#if v32_64==32
#define M1           0xffffffff         /* -1 or the bigest unsigned */
#define M2           0xfffffffe
#define THREE_Q      0xc0000000
#define MASKA_P      0xffffff
#define MASKA3       0xffffff  // one bit more for functor
#define MASKA        0xfffffff
#define MASKA1       0x1fffffff
#define MASKA2       0x3fffffff
#define HALFM        0x7fffffff

#define HALF         0x80000000
#define QUARTER      0x40000000
#define OBSEG1       0x20000000  // pred
#define OBSEG2       0x10000000  // pred without arg.
#define OBSEG3       0x8000000   // Func
#define OBSEG4       0x4000000   // Func without arg.
#define OBSEG5       0x2000000   // object name
#define OBSEG6       0x1000000   // op
                                 // other? methods? set_op?
#define LAST_FLAG    0x1000000 // OBSEG6
#define LAST_FLAG_F  0x10000000
#else
#define M1           0xffffffffffffffff         /* -1 or the bigest unsigned */
#define M2           0xfffffffffffffffe
#define THREE_Q      0xc000000000000000
#define MASKA_P      0xffffffffffffff
#define MASKA3       0xffffffffffffff  // one bit more for functor
#define MASKA        0xfffffffffffffff
#define MASKA1       0x1fffffffffffffff
#define MASKA2       0x3fffffffffffffff
#define HALFM        0x7fffffffffffffff

#define HALF         0x8000000000000000
#define QUARTER      0x4000000000000000
#define OBSEG1       0x2000000000000000  // pred
#define OBSEG2       0x1000000000000000  // pred without arg.
#define OBSEG3       0x800000000000000   // Func
#define OBSEG4       0x400000000000000   // Func without arg.
#define OBSEG5       0x200000000000000   // object name
#define OBSEG6       0x100000000000000   // op
                                 // other? methods? set_op?
#define LAST_FLAG    0x100000000000000 // OBSEG6
#define LAST_FLAG_F  0x1000000000000000
#endif

#define NUMB_FLAGS   8

#define BLOCK       0x4000 // in connection with MAX_VARS
#define S_HALF      0x8000
#define S_MASKA     0x7fff

#define PRIME_1     7
#define PRIME_2     1031


#define TP_CALK         0x3f000000
#define TP_TAPA         0x80000000
#define TP_REAL_TAPA    0x40000000
#define TP_VAR          0x20000000
#define TP_TERM         0x10000000
#define TP_STR           0x8000000
#define TP_INT           0x4000000
#define TP_FLOAT         0x2000000
#define TP_OBJ           0x1000000
#define TP_LIST           0x800000
#define TP_IO             0x400000
#define TP_METHOD         0x200000
#define TP_STRICT         0x100000
#define TP_TEMP_FLAG       0x80000  // only when TEMP

#define TP_ALL          0xfff80000
#define MASKA_TP           0xfffff
#define MASKA_TP2          0x7ffff // MASKA_TP^TP_TEMP_FLAG

#define DF_CLASSES     0  // 19
#define DF_WINDOW      22
#define DF_DIALOG      23
#define DF_STATIC      24
#define DF_EDIT        25
#define DF_ANIMATE     26
#define DF_LISTBOX     27
#define DF_TREEBOX     28
#define DF_BITMAP      29
#define DF_ICON        30
#define DF_BUTTON      31 // 6

#define DF_MENU        38
#define DF_NORMAL      39
#define DF_POP_UP      40
#define DF_SEPARATOR   41

#define DF_INIT        42
#define DF_CLOSE       43
#define DF_PAINT       44
#define DF_PRESS       45
#define DF_MOUSE_CLICK 46
#define DF_R_MOUSE_CLICK 47
#define DF_SIZE        48
#define DF_CHAR        49
#define DF_KEY_DOWN    50

#define DF_VpMi        51  // (?-)
#define DF_DptMi       52  // :-
#define DF_Cherga      53  // [#] // used only in comented area
#define DF_TRUE        54
#define DF_FALSE       55
#define DF_OP          56
#define DF_BUILT_IN    57
#define DF_IS          58
#define DF_VAR         59
#define DF_TERM        60
#define DF_STR         61
#define DF_INT         62
#define DF_FLOAT       63
#define DF_OBJ         64
#define DF_NUM         65
#define DF_LIST        66
#define DF_SET         67
#define DF_IO          68
#define DF_METHOD      69
#define DF_NOCALK      70
#define DF_STRICT      71

#define DF_POST        72
#define DF_BEGIN       73
#define DF_END         74
#define DF_CURRENT     75
#define DF_DptMiMi     76  // :--
#define DF_NO_CASE     77
#define DF_CHECKED     78
#define DF_GRAYED      79
#define DF_DEFAULT     80
#define DF_BOLD        81 // not used
#define DF_ITALIC      82 // not used
#define DF_UNDERLINE   83 // not used
#define DF_INCLUDE     84
#define DF_BEFORE      85
#define DF_FX               86 // importand row

#define DF_FIRST            106
#define DF_LAST             107
#define DF_ROOT             108
#define DF_MOUSE_MOVE       109
#define DF_MOUSE_WHEEL      110
#define DF_MOUSE_CLICK_UP   111
#define DF_R_MOUSE_CLICK_UP 112
#define DF_KEY_UP           113
#define DF_LEFT             114
#define DF_RIGHT            115
#define DF_MIDDLE           116
#define DF_SHIFT            117
#define DF_CTRL             118
#define DF_ALT              119
#define DF_FUNCTION         120
#define DF_STATE            121
#define DF_DEFINE_SYS_VAR   122
#define DF_UNDEF_OP         123

#define DF_LIKE_ATOM        124
#define DF_LIKE_FUNCTOR     125
#define DF_LIKE_SET_CONST   126

#define DF_MAX              127
#define DF_SCROLL           128
#define DF_HORIZONTAL       129
#define DF_VERTICAL         130
#define DF_THUMB_MOVED_TO   131
#define DF_THUMB_TRACK      132
#define DF_LINE             133
#define DF_PAGE             134
#define DF_DOUBLE_CLICK     135
#define DF_FILE             136
#define DF_DIRECTORY        137
#define DF_PRINT            138
#define DF_PRINT_Q          139
#define DF_PROOF_TREE_SYS   140
#define DF_SELECTED         141
#define DF_UNSELECTED       142
#define DF_FOCUSED          143
#define DF_UNFOCUSED        144
#define DF_SCREEN           145
#define DF_LL               146
#define DF_LF               147

#define DEFINITIONS         148

#define SUBTYPE(X,Y) (ObjectStore[X+4]&ObjectStore[Y+5])==ObjectStore[Y+4]
#define WILL_CLEAN(X)  Link[sv_subv++]=X;my_gl++
#define Next_Symbol_is(symbol,flag,V1,V2) if(string2[j]==symbol){flag=V1;j++;}else{flag=V2;}


